﻿class Bullet extends FloatingMovieClips  
{
	//Constants
	private var INT_MAXTIME:Number = 77;
	//Integers
	private var int_TimeOnScreenCounter:Number = 0;
	private var int_BulletNumber:Number;
	
	public function onEnterFrame()
	{
		super.onEnterFrame();
		//check if the bullet needs  to be removed
		if(int_TimeOnScreenCounter >= INT_MAXTIME)
			takeHit();
		else
			int_TimeOnScreenCounter++;	
	}
	public function setProperties(sentX:Number, sentY:Number, sentRotation:Number, sentBulletNumber:Number):Void
	{
		super.setProperties(sentX, sentY, sentRotation);
		//set the bullet number
		int_BulletNumber = sentBulletNumber;
	}
	public function takeHit():Void
	{
		//update the array to show the bullet is removed
		_root["Player"].removeBulletFromArray(int_BulletNumber);
		//then remove the movieclip
		this.removeMovieClip();
	}
	
	private function checkCollisions():Void
	{
		super.checkCollisions();
		//check to see if the current bullet is hitting an asteroid
		_root.am_AsteroidManager.checkHittingAsteroid(this);
		//now check if the bullet hits the player
		//and check the timer to allow the bullet to first move away from the player
		if(Math.sqrt(Math.pow(this._x - _root["Player"]._x, 2) + Math.pow(this._y - _root["Player"]._y, 2)) <= (this._width/2) + (_root["Player"]._width/2)
		   && int_TimeOnScreenCounter > 5)
		{
			//update the player and the bullet
			takeHit();
			trace("Player Shot Self!");
			_root["Player"].takeHit();
		}
	}
}