﻿class FloatingMovieClips extends MovieClip 
{
	//Constants
	private var FLO_BASESPEED:Number = 5;
	//Booleans
	private var bool_PropertiesBeenSet:Boolean = false;
	private var bool_FadeIn:Boolean = true;
	//Floats
	private var flo_SpeedMutator:Number = 1;
	
	
	public function onEnterFrame()
	{
		//check if properties have been set for the movieclip
		if(bool_PropertiesBeenSet)
		{
			//move the player based on it's current angle
			this._x += (FLO_BASESPEED * flo_SpeedMutator)* Math.sin(this._rotation * (Math.PI / 180));
			this._y -= (FLO_BASESPEED * flo_SpeedMutator)* Math.cos(this._rotation * (Math.PI / 180));
			//run collision checks
			checkCollisions();
			//run fade script
			if(bool_FadeIn && this._alpha < 100)
				this._alpha += _root.NUM_FADESPEED;
			else if(!bool_FadeIn && this._alpha > 0)
				this._alpha -= _root.NUM_FADESPEED;
		}
	}
	
	public function setProperties(sentX:Number, sentY:Number, sentRotation:Number):Void
	{
		//Use the sent properties to intalise the movielclip
		setX(sentX);
		setY(sentY);
		this._rotation = sentRotation;
		//show that the movie has been set up 
		bool_PropertiesBeenSet = true;
	}
	
	public function	setX(sentX:Number):Void
	{
		this._x = sentX;
	}
	
	public function setY(sentY:Number):Void
	{
		this._y = sentY;
	}
	
	public function	getX():Number
	{
		return this._x;
	}
	
	public function getY():Number
	{
		return this._y;
	}
	
	public function getDirection():Number
	{
		return this._rotation;
	}

	public function setSpeedMutator(sentValue:Number)
	{
		flo_SpeedMutator = sentValue;
	}

	public function fadeOut():Void
	{
		bool_FadeIn = false;
	}

	public function fadeIn():Void
	{
		bool_FadeIn = true;
	}
		
	private function checkCollisions():Void
	{
		//Uses the same basic collision as the player so when it goes off
		//screen it reappear on the oppersite side
		
		if(this._x < 0 - (this._width/2))
			setX(Stage.width + (this._width/2));
		else if(this._x > Stage.width + (this._width/2))
			setX(0 - (this._width/2));
		
		else if(this._y < 0 - (this._height/2))
			setY(Stage.height + (this._height/2));
		else if(this._y > Stage.height + (this._height/2))
			setY(0 - (this._height/2));
	}
}